/**
 * Diese Klasse dient dazu, die Anzahl jedes Buchstaben in einem String zu z&auml;hlen.
 * 
 * @author Owyn
 * @version 2008-04-24
 */
public class LetterCounter2 {
    
    /**
     * Hauptprogramm.
     * 
     * @param args  Das erste Arrayelement enth&auml;lt den zu bearbeitenden Text.
     */
    public static void main(String[] args) {
        if (args.length == 1) print(count(args[0]));
    }
    
    /**
     * Z&auml;hlt alle Vorkommen jedes Buchstabens im &uuml;bergebenen String.
     * 
     * @param text  Enth&auml;lt den zu bearbeitenden Text.
     * @return      Ein int-Array, das die Anzahl der Vorkommen von A bis Z enth&aulm;lt.
     */
    public static int[] count(String text) {
        int[] lettersCounter = new int[26];
        
        text = text.toUpperCase(); // Umwandeln in Grossbuchstaben
        
        for (int i =0; i < text.length(); i++) {
            if (text.charAt(i) >= 'A' && text.charAt(i) <= 'Z') // Wenn das aktuelle Zeichen ein Buchstabe ist: ...
              lettersCounter[text.charAt(i) - 'A']++; // ...diesen zaehlen.
        }
        
        return lettersCounter;
    }
    
    /**
     * Gibt ein &uuml;bergebenes int-Array aus. Der Index "0" entspricht dem
     * Buchstaben "A" und der Index "26" entspricht dem Buchstaben "Z". 
     * Die Werte des Arrays ensprechen der Anzahl der Vorkommen des jeweiligen Buchstabens.
     * 
     * @param a     Enth&auml;lt die Buchstabenanzahlen.
     */
    public static void print(int[] a){
        for (int i = 0; i < a.length; i++){
            if (a[i] > 0) // Nur ausgeben, wenn der Buchstabe vorkommt
              System.out.println( (char)(i + 'A') + ": " + a[i]);
        }
    }

}
